####################################
# Commander Keen in: Bad Carma(ck) #
####################################

%ext ck1
%version 1.31

##########
# Basics #
##########

%patch $14F1D "Loading Commander Keen in...Bad Carma(ck) (31/08/11)   "

#Infinite replays of all levels:
%patch $8019 $00

#Keen doesn't lose ship parts on dying in their levels.
%patch $4F82 $90 $90 $90 $90 $90 $90 #Joystick
%patch $4F8A $90 $90 $90 $90 $90 $90 #Battery
%patch $4F92 $90 $90 $90 $90 $90 $90 #Vacuum
%patch $4F9A $90 $90 $90 $90 $90 $90 #Whiskey

#Doors do not take keys when doors opened
%patch $28D7 $00

#Don't take keys on level exit
%patch $4F51 $90 $90 

#Change the controls to: Space, shoot; Enter, status.
%patch $1251  $48
%patch $7FA3  $48
%patch $3B23  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00
%patch $3C4E  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00
%patch $3DB9  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00
%patch $3DCC  $90 $90
%patch $3E6D  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00
%patch $3FFC  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00
%patch $40AA  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00

#Movement
# %patch $2BC5 $FFFEW  #Running speed left
# %patch $2BB6 $0001W  #Running speed right
# %patch $39F6 $05     #Animation speed right
# %patch $3A19 $05     #Animation speed left
%patch $3BAC $05 $00 #Keen's jump height [in *half* tiles, default 6]
%patch $3F3C $FFFEW  #Keen's high pogo height variable lower is higher

# %patch $3472 $00 $A0  #Scroll Right lag FF
# %patch $34C0 $00 $A0  #Scroll Left lag 30
%patch $350C $00 $70  #Scroll Down lag
%patch $355A $00 $30  #Scroll Up lag

#Scores
%patch $15078 $000AW #LOLLY
%patch $1507A $0014W #SODA
%patch $15076 $001EW #PIZZA
%patch $1507C $0028W #BOOK
%patch $1507E $0032W #TEDDY

#What Keen starts with
%patch $9012 $94 $AA $01 #joystick
%patch $901E $96 $AA $01 #vacuum
%patch $9024 $98 $AA $01 #everclear
%patch $9008 $FF $FF     #almost infinite ammunition
%patch $900E  $01 $00    #pogo

%patch $44A2 $C8 $AA $FF #Raygun gives -1 ammo

#Disable on-map teleportation (one-way from level TP)
%patch $AF2C $8B $E5 $5D $C3

#When Keen is bumped by a Bot he:
%patch $4649 $0000W #Jumps this high (Not at all)
%patch $4654 $0000W #Is pushed right this much or
%patch $465B $0000W #Left this much

##################################
# CHAIN BECOMES DESTROYABLE WALL #
##################################

#Make falling block one tile
%patch $238D $0001W #Top left tile here
%patch $23F4 $0001W #Left end of ALL middle tiles
%patch $2465 $01   #Right end of block middle
%patch $2476 $0001W #Top right tile here

#Make block tiles background
%patch $23CD $009BW #Top left
%patch $2436 $009BW #Top middle
%patch $24B6 $009BW #Top right
%patch $23EF $009BW #Bottom left
%patch $2458 $009BW #Bottom middle
%patch $24D8 $009BW #Bottom right

#Relative location of falling block to chain
%patch $23B5 $FF   #Top left
%patch $241E $FF   #Top middle
%patch $249E $FF   #Top right
%patch $23D7 $FF   #Bottom left
%patch $2440 $FF   #Bottom middle
%patch $24C0 $FF   #Bottom right

#stop replacement tiles from appearing
%patch $23AA $C3 #left replacement
%patch $2413 $C3 #middle replacement
%patch $2493 $C3 #right replacement

%patch $24E8 $01 #Number of fall cycles

%patch $24DC $00 #Make block fall l/r instead of u/d

#Don't make falling block sound:
%patch $2347 $90 $90 $90

#########
# Death #
#########

%patch $9002 $00 $00 #Start with 0 lives
%patch $8041 $00 $06 $C2 $6E #Keen doesn't lose a life on dying 
%patch $0FB0 $00 $00 #No "extra keen at" score

# skip keens left 
%patch $7E99 $90 $90 $90 # skip the display_keens_left() call 
%patch $7EBC $90 $90 $90 # skip the delay() call

#%patch $8F2E $90 $90 #Keens Left box height 
#%patch $8F32 $90 $90 #Keens Left box width

##########
# Cheats #
##########

#Disable CTSpace cheat via keyboard
%patch $11F5 $2C $50
%patch $11FC $2C $50
%patch $1203 $2C $50

# Disable the god-mode cheat via keyboard
%patch $120D  $2C $50 
%patch $1214  $2C $50
%patch $121B  $2C $50

#CTSpace takes everything but keycards
%patch $0E01 $C8 $AA $00 $00 #Ammo
%patch $0DFB $9C $AA $00 $00 #Battery
%patch $0E0F $94 $AA $00 $00 #Other parts and pogo

# Activate CTSpace cheat when you hit the battery 
%patch $4452 $E8 $C95BW $90 $90 $90

#GOD only makes you invincible
%patch $A626 $EB #no clipping off
#%patch $A621 $EB #Vort 2 version
%patch $3F4E $EB #pogo fly off

# enable god mode if you have the joystick when you enter a level 
#this code is needed to free up some space

#Rewrite tile routine to free up 15Kb
%patch $11F80 $06 $1E $50 $A1 $B2 $35 $8E $C0 $A1 $6A $83 $8E $D8 $A4 $A4 $03
              $FA $A4 $A4 $03 $FA $A4 $A4 $03 $FA $A4 $A4 $03 $FA $A4 $A4 $03
              $FA $A4 $A4 $03 $FA $A4 $A4 $03 $FA $A4 $A4 $03 $FA $A4 $A4 $03
              $FA $A4 $A4 $03 $FA $A4 $A4 $03 $FA $A4 $A4 $03 $FA $A4 $A4 $03
              $FA $A4 $A4 $03 $FA $A4 $A4 $03 $FA $A4 $A4 $03 $FA $58 $1F $07
              $C3 $BA $2E $00 $66 $33 $C0 $8B $C3 $66 $8B $D8 $66 $33 $C0 $8B
              $C8 $3D $26 $01 $7D $35 $67 $26 $8B $34 $43 $D1 $E6 $8B $32 $67
              $3B $34 $45 $16 $5B $00 $00 $74 $13 $67 $89 $34 $45 $16 $5B $00
              $00 $67 $8B $3C $45 $C0 $35 $00 $00 $E8 $74 $FF $40 $41 $83 $F9
              $15 $7C $CE $33 $C9 $03 $1E $54 $56 $EB $C6 $CB $BA $2E $00 $66
              $33 $C0 $8B $C3 $66 $8B $D8 $66 $33 $C0 $8B $C8 $3D $26 $01 $7D
              $35 $67 $26 $8B $34 $43 $D1 $E6 $8B $32 $67 $3B $34 $45 $B8 $5D
              $00 $00 $74 $13 $67 $89 $34 $45 $B8 $5D $00 $00 $67 $8B $3C $45
              $C0 $35 $00 $00 $E8 $29 $FF $40 $41 $83 $F9 $15 $7C $CE $33 $C9
              $03 $1E $54 $56 $EB $C6 $CB

%patch $B7B2 $3911W #UpdateFarCall to ADT_0
%patch $B7AA $395CW #UpdateFarCall to ADT_1

# back to god mode
# the very end of the level init function was moved so we can add stuff -- jump to the new locat 
%patch $1703 $E9 $CFBAW 
# the joystick check itself - sans message 
%patch $E6C0 $83 $3E $94 $AA $01        # cmp joystick, 1 
             $75 $06                    # jne 06 
             $C7 $06 $AA $5D $01 $00    # mov godmode, 1 
             $5F $5E $8B $E5 $5D        # pop di; mov sp, bp; pop bp; 
             $C3                        # retn

################
# Text Patches #
################

%patch 0x015F12 "About id..."
%patch 0x015F32 "About Flaose "

#About Flaose
%patch 0x01632C "  Who is Flaose anyways?"
%patch 0x016346 " Flaose is a gamer who's "
%patch 0x016364 "getting way too old"
%patch 0x01637B "   for video games.  "
%patch 0x016392 "He, however, for some    "
%patch 0x0163AD "reason thought that it   "
%patch 0x0163C8 "was a good idea to start "
%patch 0x0163E4 "      patching again.                "
%patch 0x01640D "Flaose still attends university,   "
%patch 0x016434 "sometimes dabbles in the Keen      "
%patch 0x01645B "Community, and promises that this"
%patch 0x016480 "will be his last mod.      "
%patch 0x0164B5 "Flaose still   "
%patch 0x0164DD "considers      "
%patch 0x016505 "himself bad at "
%patch 0x01652D "biographies.     "
%patch 0x0164EE "               "
%patch 0x016516 "               "
%patch 0x016542 "                                        "
%patch 0x016573 "                                  "
%patch 0x0164C6 "     "
%patch 0x0164CB "                 "

#About ID...
%patch 0x015F80 "id is a group of software artists "
%patch 0x015FA8 "who have created many popular    "
%patch 0x015FD0 "games such as Wolfenstein 3D, "
%patch 0x015FF8 "DOOM, and Quake.    "
%patch 0x016020 "They may have forgotten Keen,   "
%patch 0x016048 "but Keen hasn't forgotten them.... "
%patch 0x016070 "                          "
%patch 0x016098 "                       "
%patch 0x0160C0 "                             "
%patch 0x0160E8 "                                 "
%patch 0x016110 "                         "

#Status Screen
%patch 0x014E56 "SCORE"
%patch 0x014E60 "             "
%patch 0x014E77 "     "
%patch 0x014E83 "COMPONENTS"
%patch 0x014E9B "CANNON"
%patch 0x014EA4 "FUEL"
%patch 0x014EAC "CLEARANCE"
%patch 0x014EC8 "CHARGE"

#CTSpace
%patch 0x014DEE "MALFUNCTION!         "
%patch 0x014E05 "                          "
%patch 0x014E21 "Main systems offline. "
%patch 0x014E39 "Using backup power.     "

#Set up any-level Yorp message patch:
#Messages in levels 2-32:
%patch $251D $1E

#Point to new code:
%patch $2528 $25E4W

#Level pointers:
%patch $25E4 $252AW $2530W $2536W $253CW $2542W $2548W $254EW $2554W $255AW $2560W 
             $2566W $256CW $2572W $2578W $257EW $2584W $258AW $2590W $2596W $259CW 
             $25A2W $25A8W $25AEW $25B4W $25BAW $25C0W $25C6W $25CCW $25D2W $25D8W 
             $25DEW 


#Level 2's Yorp message:
%patch $252A $B8 $2030W $E9 $0175W
%patch $15080 "Ha ha ha," $0A
              "Commander Keen you" $0A
              "fool!  You've fallen" $0A
              "for my trap!  Did you" $0A
              "really think that it" $0A
              "would be that easy?" $0A $0A
              "Your suit won't make" $0A
              "it through that" $0A
              "plasma disruption" $0A
              "field unscathed, and" $0A
              "nobody has ever" $0A
              "returned from the" $0A
              "other side of that" $0A
#              "teleporter.  Goodbye," $0A
#              "Commander Keen!" $0A $0A
 $00


#Level 3's Yorp message:
%patch $2530 $B8 $214BW $E9 $016FW
%patch $1519B "Jetfuel component" $0A
              "reinitialized. " $0A
              "Secondary jump" $0A
              "booster jet enabled." $0A $0A $00


#Level 4's Yorp message:
%patch $2536 $B8 $2193W $E9 $0169W
%patch $151E3 "Bad Carma(ck)" $0A
              "encourages" $0A
              "exploration.  Because" $0A
              "of this, all levels" $0A
              "can be re-entered," $0A
              "and should you lack" $0A
              "the necessary tools" $0A
              "to get to the other" $0A
              "side of a level, you" $0A
              "will always find an" $0A
              "exit at the entrance." $0A $0A
#              "As well, lives are" $0A
#              "unlimited and not" $0A
#              "tracked in any way." $0A $0A
 $00


#Level 5's Yorp message:
%patch $253C $B8 $2266W $E9 $0163W
%patch $152B6 "Access Cards are" $0A
              "needed to access" $0A
              "the different secured" $0A
              "areas, as such, they" $0A
              "are not 'used up' by" $0A
              "doors and are carried" $0A
              "from level to level. " $0A
              "Try it out!" $0A $0A $00


#Level 6's Yorp message:
%patch $2542 $B8 $2302W $E9 $015DW
%patch $15352 "You've picked up the" $0A
              "Plasma Charge Pack! " $0A
              "You now have" $0A
              "near-infinite ammo. " $0A
              "Try shooting that" $0A
              "destructible wall and" $0A
              "go through the hidden" $0A
              "wall to the exit." $0A $0A $00


#Level 7's Yorp message:
%patch $2548 $B8 $23A0W $E9 $0157W
%patch $153F0 "You've picked up a" $0A
              "piece of the Big" $0A
              "Purple Space Amoeba! " $0A
              "Invincibility" $0A
              "Charging!" $0A $0A $00

#Level 9's Yorp message:
%patch $2554 $B8 $B000W $E9 $014BW
%patch $1E050 "You win the game by" $0A
              "killing Adrian" $0A
              "Carmack." $0A $0A $00

##############
# The Ending #
##############

%patch $8022 $94 $AA $02 $72 #Collecting ship parts doesn't end game

%patch $1DAD $8C $81 #Game ends when Carmack is killed

%patch $1819 $0000 #Strength of Adrian Carmack -1

#End sequence skip first part:
#%patch $81A3 $02
#Map level
#%patch $81CA $52 $00
#Don't show Keen on the map
#%patch $81F9 $01 
#Flight to Earth level
#%patch $8253 $52 $00 
#Write quicker
#%patch $8173 $0001W

%end